//
// Change this code to use the CircularList class
// instead of the DoublyLinkedList class
//

object JosephusCircular {
  
  def josephus(n: Int, m: Int): String = {
    val L = new DoublyLinkedList
    for (i <- 1 to n)
      L.append(('A' + i - 1).toChar.toString)
    var p = L.first
    for (i <- 1 until n) {
      println(L + " " + p.el)
      for (j <- 1 to m) {
	p = p.next
	if (p.el == null)
          p = L.first
      }
      val q = p
      p = p.next
      if (p.el == null)
	p = L.first
      L.remove(q)
    }
    L.first.el
  }

  def main(args: Array[String]) {
    val result = josephus(args(0).toInt, args(1).toInt)
    println("The last one is " + result)
  }
}

